<p align="center">
  <a href="https://to.reframe.is/DJwN" target="_blank"><img
    height="60"
    src="https://d3g1vr8yw3euzd.cloudfront.net/media/img/reframe-full.svg" alt="ReframeAI logo"></a>
</p>

<p align="center">
    <b>Reframe » Low-Code Database Supercharged by AI Agents</b>. <br />
    The fastest way to build, deploy and managed AI Agents on your dataframes. <br /> Automate workflows you once spent countless human hours on!
</p>

<p align="center">
  <a href="https://to.reframe.is/discord" target="_blank">
  <img
    width="180"
    height="30"
    src="https://img.shields.io/discord/1161074849364586536?style=for-the-badge&logo=discord&logoColor=white&labelColor=5865F2&label=Discord"
    alt="Discord AI"
  />
</a>
</p>

<p align="center">
  <a href="https://reframe.is/docs/" target="_blank">
      📖 Docs
  </a> |
  <a href="https://to.reframe.is/DJwN" target="_blank">
      🏠 Homepage
  </a>
</p>


## About


Reframe is an experimental agent framework powered by GPT-4 that operates on dataframes.

 <a href="https://youtu.be/M860LUfwiQc">
   <img
     src="https://d3g1vr8yw3euzd.cloudfront.net/media/img/reframe-screen-recording.gif"
     alt="Discord AI"
   />
 </a>

Reframe unleashes the future with AI Agents that work for you. These virtual assistants automate workflows,
search the web, explore LinkedIn, and more - with human-like intelligence but without human limitations.
Reframe combines an effortless a low-code database, dozens of tireless AI agents and powerful Language Models like
GPT, so you can manage data smarter, not harder. Let AI Agents do the work so you can focus on insights.

Come chat with us

<a href="https://to.reframe.is/discord">
  <img
    width="210"
    height="40"
    src="https://img.shields.io/discord/1161074849364586536?style=for-the-badge&logo=discord&logoColor=white&labelColor=5865F2&label=Discord"
    alt="Discord AI"
  />
</a>


[Installation](#installation) |  [Quick Start](#quick-start) | [Documentation](#documentation)

## Installation
### 1. Automatic Installation
By far the easiest way to install the ReframeAI server is to use the install script.
```shell
pip install reframe-py
```

Documentation: [https://reframe.is/docs](https://to.reframe.is/docs)

ReframeAI comes with some pre-built AI Agents. Alternatively, you can write your own.

## Reframe strives to be

* 🥽 Transparent - through logging, and metrics that create visibility into the inner operations.
* 🤸🏾 Flexible - AI Agents and tools are independent of each other, allowing you to create workflows easily.
* 🧩 Composable. Reframe are simply executable python functions and classes with a well defined interface. You can easily construct sophisticated agents from basic building blocks. These building blocks can be obtained from our ecosystem or you can develop custom ones that are specific to your organization.
* 🛹 Incrementally adoptable - By using existing technologies such as Docker, Kubernetes and Celery Aigent enables you to seamlessly adopt it with your organization. From simple ZeroShot agents to sophisticated multi-step AI agents each component can be integrated into your existing workflows.
* 🔨 Reusable - once a tool is running, it can be utilized by various agents, thereby reducing operational overhead, increasing throughput and making tools easy to reason about.
* 🏎️ Fast by taking advantage of data parallelism and prompt sequencing in a manner increases efficiency and reduces the overall number of expensive API calls made to LLM endpoints.
* 🏟️ Rich ecosystem that enables your to pick and choose which tools and agents to deploy. Through contributions from open source developers, we are making great progress to develop a robust ecosystem of tools so that you always have a tool for the job.

# Features
* 🌐 Internet access for searches and information gathering
* 📥 Long-term and short-term memory management 
* 🧠 GPT-4 & Anthropic instances for text generation 
* 🔗 Access to popular websites and platforms 
* 🗃️ File storage and summarization with GPT-3.5 
* 🔌 Extensibility with Plugins

## Status

- [x] Alpha: We are testing Reframe with a closed set of customers
- [x] Public Alpha: Anyone can sign up over at [https://reframe.is](https://to.reframe.is/sign-up). But go easy on us, there are a few kinks
- [ ] Public Beta: Stable enough for most non-enterprise use-cases
- [ ] Public: General Availability

We are currently in Public Beta. Watch "releases" of this repo to get notified of major updates.

## Documentation
More documentation is available here: [https://reframe.is/docs](https://to.reframe.is/docs)